# -*- ruby -*-

#
# VFS for ruby - open anything with URI
# 
#   Copyright: Tatsuki Sugiura <sugi@nemui.org>
#   License: Ruby's original or GPL2
#   $LastChangedDate: 2003-10-22 09:11:42 +0900 (Wed, 22 Oct 2003) $
#   $LastChangedBy: sugi $
#

require 'vfs/dir'
require 'vfs/scheme/file/common'

module VFS; module SchemeHandler; module FILE
  class Dir < VFS::Dir
    include VFS::SchemeHandler::FILE::Common
    extend  VFS::SchemeHandler::FILE::MethodGenerator

    relay_realpath_to_dir_builtin :mkdir, :entries, :[],
      :unlink, :glob, :foreach, :rmdir, :getwd, :delete

    def open(*arg, &block)
      ::DirBuiltIn.open(uri.path, *arg, &block)
    end

  end # VFS::SchemeHandler::FILE::Dir
end; end; end


if __FILE__ == $0
  url = "file:///tmp/rvfs-test.#{Time.now.to_i}"
  d = VFS::SchemeHandler::FILE::Dir.new(url)
  p d
  p d.send(:uri).path
  d.mkdir
  system("ls -ld #{d.__send__(:uri).path}")
  d.open{ |h|
    h.each{|e|
      p e
    }
  }
  p VFS::SchemeHandler::FILE::Dir.entries(url)
  d.rmdir
  system("ls -ld #{d.__send__(:uri).path}")
end

